routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

// Route::get('/', function () {
//     return view('welcome');
// });

Route::get('login/google', 'Auth\LoginController@redirectToProvider');
Route::get('login/google/callback', 'Auth\LoginController@handleProviderCallback');

Route::get('/', 'GuestController@index')->name('guest');

Auth::routes(['verify' => true]);

Route::group(['prefix' => 'internal', 'middleware' => ['role:admin|manager|staff']], function() {
    Route::get('/home', 'InternalController@index')->name('home');
    Route::resource('order', 'OrderController');
});

Route::group(['prefix' => 'internal', 'middleware' => ['role:admin|manager']], function() {
    Route::resource('hotel', 'HotelController');
    Route::resource('log', 'ActivityLogController');
    Route::resource('staff', 'StaffController');

});

Route::group(['prefix' => 'admin', 'middleware' => ['role:admin']], function() {
    Route::get('user', 'UserController@userIndex')->name('user.index');
    Route::get('user/{id}/view', 'UserController@userView')->name('user.view');
    Route::get('user/{id}/edit', 'UserController@userEdit')->name('user.edit');
    Route::patch('user/update', 'UserController@userUpdate')->name('user.update');
    Route::get('user/create', 'UserController@userCreate')->name('user.create');
    Route::post('user/store', 'UserController@store')->name('user.store');
    Route::delete('user/{id}/delete', 'UserController@destroy')->name('user.destroy');

});

Route::group(['prefix' => 'member', 'middleware' => ['verified','role:member']], function() {
    Route::get('/home', 'MemberController@index')->name('member.home');
    Route::patch('user/update', 'UserController@userUpdate')->name('member.user.update');
    Route::resource('booking', 'OrderController');
    // Route::get('/manage', ['middleware' => ['permission:manage-admins'], 'uses' => 'AdminController@manageAdmins']);
});



Route::get('/profile/edit', 'UserController@userEdit')->name('profile.edit');
Route::get('/profile/view', 'UserController@userView')->name('profile.view');

app/Order.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Wildside\Userstamps\Userstamps;
use Spatie\Activitylog\Traits\LogsActivity;
use Illuminate\Database\Eloquent\SoftDeletes;


class Order extends Model
{
    use Userstamps;
    use LogsActivity;
    use SoftDeletes;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'hotel_id', 'room_id', 'customer_id', 'payment_status','checkedin_status','book_start','book_end','checkedout_at'
    ];

    protected static $logFillable = true;

    public function room()
    {
        return $this->belongsTo('App\Room');
    }
    public function hotel()
    {
        return $this->belongsTo('App\Hotel');
    }
    public function user()
    {
        return $this->belongsTo('App\User','customer_id','id');
    }
}

app/Http/Controllers/InternalController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

use App\Hotel;
use Auth;

class InternalController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Contracts\Support\Renderable
     */
    public function index()
    {
        $hotels = Hotel::where('manager_id', Auth::user()->id )->get();

        return view('internal.home',compact('hotels'));
    }
}

app/Http/Controllers/OrderController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

use App\Order;
use App\Hotel;
use App\Room;
use App\Staff;
use App\User;
use App\RoomType;


use Auth;
use Carbon\Carbon;

class OrderController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        if(Auth::user()->hasRole('admin'))
            $orders = Order::paginate(20);

        if(Auth::user()->hasRole('manager')) {
            $hotels = Hotel::where('manager_id', Auth::user()->id )->get()->toArray();

            foreach ($hotels as $key => $value) {
                $hotelArray[] = $value['id'];
            }

            $orders = Order::whereIn('hotel_id',$hotelArray)->paginate(20);

        }
        if(Auth::user()->hasRole('staff')) {
            $hotel = Staff::where('user_id', Auth::user()->id )->first();

            if(!$hotel)
                return redirect()->route('home')->withFlashError('Not Asigned to any Hotel');

            $orders = Order::where('hotel_id',$hotel->hotel_id)->paginate(20);
        }
        if(Auth::user()->hasRole('member')) {
            $orders = Order::where('customer_id',Auth::user()->id)->paginate(20);
        }

        return view('internal.order.index', compact('orders'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {

        $hotels = Hotel::all();
        $type = RoomType::all();
        $users = User::whereRoleIs('member')->get();
        // dd($type);

        return view('internal.order.create', compact('users','hotels','type'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        // dd($request);

        $order = New Order;

        if(Auth::user()->hasRole('member'))
            $order->customer_id = Auth::user()->id;
        else
            $order->customer_id = $request->customer_id;

        $order->hotel_id = $request->hotel_id;
        $order->room_id = $request->room_id;
        $order->book_start = Carbon::parse($request->book_start)->toDateTimeString();
        $order->book_end = Carbon::parse($request->book_end)->toDateTimeString();

        $order->save();

        activity()
        ->withProperties(['order' => $order])
        ->log('New Booking Order');

        if(Auth::user()->hasRole('member'))
            return redirect()->route('booking.index')->withFlashSuccess('Booking Order Created');
        else
            return redirect()->route('order.index')->withFlashSuccess('Booking Order Created');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $order = Order::findOrFail($id);

        if(Auth::user()->hasRole('member')) {
            $customer = Auth::user();
            if( $customer->id !== $order->customer_id )
                return redirect()->route('booking.index')->withFlashError('Not Your Booking Order');
        }

        return view('internal.order.view', compact('order'));

    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $order = Order::findOrFail($id);

        if(Auth::user()->hasRole('member')) {
            $customer = Auth::user();
            if( $customer->id !== $order->customer_id )
                return redirect()->route('booking.index')->withFlashError('Not Your Booking Order');
        }

        $hotels = Hotel::all();
        $type = RoomType::all();

        // dd($type);

        return view('internal.order.edit', compact('order','hotels','type'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        // dd($request);

        $order = Order::findOrFail($id);

        if(Auth::user()->hasRole('member')) {
            $customer = Auth::user();
            if( $customer->id !== $order->customer_id )
                return redirect()->route('booking.index')->withFlashError('Not Your Booking Order');
        }

        $order->hotel_id = $request->hotel_id;
        $order->room_id = $request->room_id;
        $order->book_start = Carbon::parse($request->book_start)->toDateTimeString();
        $order->book_end = Carbon::parse($request->book_end)->toDateTimeString();

        $order->save();

        activity()
        ->withProperties(['order' => $order])
        ->log('Order Updated');

        if(Auth::user()->hasRole('member'))
            return redirect()->route('booking.index')->withFlashSuccess('Booking Order Updated');
        else
            return redirect()->route('order.index')->withFlashSuccess('Booking Order Updated');
        // dd($room);

    //   "user_id" => "64"
    //   "name" => "Member"
    //   "hotel_id" => "8"
    //   "room" => "studio"
    //   "book_start" => "02/05/2020"
    //   "book_end" => "02/07/2020"
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $order = Order::findOrFail($id);

        if(Auth::user()->hasRole('member')) {
            $customer = Auth::user();
            if( $customer->id !== $order->customer_id )
                return redirect()->route('booking.index')->withFlashError('Not Your Booking Order');
        }

        activity()
        ->withProperties(['order' => $order])
        ->log('Order Deleted');

        $order->delete();

        if($order)
            return response()->json(['message' => 'success'], 200);
        else
            return response()->json(['message' => 'Order is being used'], 400);
    }
}

resources/views/internal/order/create.blade.php
@extends('layouts.backend')

@section('content')
<div class="container-fluid">
@role('member')
{{ html()->form('POST', route('booking.store'))->class('form-horizontal')->open() }}
@else
{{ html()->form('POST', route('order.store'))->class('form-horizontal')->open() }}
@endrole
  <div class="card shadow mb-4">
    <div class="card-header py-3">
      <h6 class="m-0 font-weight-bold text-primary">Add New Booking</h6>
    </div>
    <div class="card-body">
        <div class="row mt-4 mb-4">
          <div class="col">
            @role('member')
                <input name="customer_id" value="{{ Auth::user()->id }}" hidden>
            @else
                <div class="form-group row">
                    {{ html()->label('Customer Name')->class('col-md-2 form-control-label')->for('customer_id') }}
                    <div class="col-md-10">
                        {{ html()->select('customer_id', $users->pluck('name','id'))
                            ->class('form-control')
                            ->required() }}
                    </div><!--col-->
                </div><!--form-group-->
            @endrole
            <div class="form-group row">
              {{ html()->label('Hotel')->class('col-md-2 form-control-label')->for('hotel_id') }}
                <div class="col-md-10">
                    {{ html()->select('hotel_id', $hotels->pluck('name','id'))
                        ->class('form-control hotel')
                        ->required() }}
                </div><!--col-->
            </div><!--form-group-->
            <div class="form-group row">
              {{ html()->label('Room Type')->class('col-md-2 form-control-label')->for('room') }}
                <div class="col-md-10">
                    {{ html()->select('room', $type->pluck('type','type'))
                        ->class('form-control')
                        ->required() }}
                    {{-- {{ html()->select('room_id')
                    ->class('form-control')
                    ->required() }} --}}
                </div><!--col-->
            </div><!--form-group-->
            <div class="form-group row">
                {{ html()->label('Room Number')->class('col-md-2 form-control-label')->for('room_id') }}
                  <div class="col-md-10">
                      {{ html()->select('room_id')
                          ->class('form-control')
                          ->required() }}
                      {{-- {{ html()->select('room_id')
                      ->class('form-control')
                      ->required() }} --}}
                  </div><!--col-->
              </div><!--form-group-->

            <div class="form-group row">
                {{ html()->label('Book Start')->class('col-md-2 form-control-label')->for('book_start') }}
                  <div class="col-md-10">
                      {{ html()->date('book_start')
                          ->class('form-control')
                          ->required() }}
                  </div><!--col-->
              </div><!--form-group-->
              <div class="form-group row">
                {{ html()->label('Book End')->class('col-md-2 form-control-label')->for('book_end') }}
                  <div class="col-md-10">
                      {{ html()->date('book_end')
                          ->class('form-control')
                          ->required() }}
                  </div><!--col-->
              </div><!--form-group-->
          </div>
        </div>

    </div>
    <div class="card-footer">
      <div class="row">
          <div class="col">
              @role('member')
              <a href="{{ route('booking.index') }}" class="btn btn-danger btn-sm">Cancel</a>
              @else
              <a href="{{ route('order.index') }}" class="btn btn-danger btn-sm">Cancel</a>
              @endrole
          </div><!--col-->

          <div class="col text-right">
            <button type="submit" class="btn btn-sm btn-success"><i class="fa fa-save"></i> Save</button>
              {{-- {{ form_submit('Update') }} --}}
          </div><!--row-->
      </div><!--row-->
    </div><!--card-footer-->
  </div>
  {{ html()->form()->close() }}
</div>
@endsection
@push('after-scripts')
<script>
$(document).ready(function() {
    $('#customer_id').select2({
        theme: 'bootstrap4',
        width: '100%',
    });
    $('#hotel_id').select2({
        theme: 'bootstrap4',
        width: '100%',
    });
    $('#room').select2({
        theme: 'bootstrap4',
        width: '100%',
    });

    $('#room').change(function () {
        if ($(this).val()) {
            console.log($('#hotel_id option:selected').val());
            console.log($('#room option:selected').val());
            var idHotel = $('#hotel_id option:selected').val();
            var roomType = $('#room option:selected').val();
            // $('#room_id').prop('disabled', false);
            $('#room_id').select2({
                width: '100%',
                theme: 'bootstrap4',
                minimumResultsForSearch: 1,
                placeholder: "Ketik 1 huruf untuk cari",
                ajax: {

                    url: '/api/room/available?hotel_id=' + idHotel +'&room=' + roomType,
                    type: 'GET',
                    dataType: 'json',
                    contentType:'application/json',
                    data: function (params) {
                        var query = {
                            q: params.term,
                        };
                        return query;
                    },
                    processResults: function (data, params) {
                        var myResults = [];
                        //console.log(data);
                        $.each(data, function (key, val) {
                            myResults.push({
                                'id': val.id,
                                'text': '['+ val.number + '] ' + val.type + ' - Rp ' + val.price
                            });
                        });
                        params.page = params.page || 1;
                        var paginate = (params.page * 10) < data.count_filtered;

                        return {
                            results: myResults,
                            pagination: {
                                more: paginate
                            }
                        };

                    },
                    //cache: true
                }
            });
        }
    });
});
</script>
@endpush

resources/views/internal/order/edit.blade.php
@extends('layouts.backend')

@section('content')
<div class="container-fluid">
@role('member')
{{ html()->form('PATCH', route('booking.update', $order->id ))->class('form-horizontal')->open() }}
@else
{{ html()->form('PATCH', route('order.update', $order->id ))->class('form-horizontal')->open() }}
@endrole
  <div class="card shadow mb-4">
    <div class="card-header py-3">
      <h6 class="m-0 font-weight-bold text-primary">Edit Booking Detail</h6>
    </div>
    <div class="card-body">
        <div class="row mt-4 mb-4">
          <div class="col">
            <div class="form-group row">
              {{ html()->label('Name')->class('col-md-2 form-control-label')->for('user_id') }}
                <div class="col-md-10">
                    {{ html()->text('user_id')
                        ->class('form-control')
                        ->value($order->customer_id)
                        ->attributes(['hidden' => 'hidden']) }}
                    {{ html()->text('name')
                        ->class('form-control')
                        ->value($order->user->name)
                        ->attributes(['readonly' => 'readonly']) }}
                </div><!--col-->
            </div><!--form-group-->
            <div class="form-group row">
              {{ html()->label('Hotel')->class('col-md-2 form-control-label')->for('hotel_id') }}
                <div class="col-md-10">
                    {{ html()->select('hotel_id', $hotels->pluck('name','id'), $order->hotel_id)
                        ->class('form-control hotel')
                        ->required() }}
                </div><!--col-->
            </div><!--form-group-->
            <div class="form-group row">
              {{ html()->label('Room Type')->class('col-md-2 form-control-label')->for('room') }}
                <div class="col-md-10">
                    {{ html()->select('room', $type->pluck('type','type'))
                        ->class('form-control')
                        ->required() }}
                    {{-- {{ html()->select('room_id')
                    ->class('form-control')
                    ->required() }} --}}
                </div><!--col-->
            </div><!--form-group-->
            <div class="form-group row">
                {{ html()->label('Room Number')->class('col-md-2 form-control-label')->for('room_id') }}
                  <div class="col-md-10">
                      {{ html()->select('room_id')
                          ->class('form-control')
                          ->required() }}
                      {{-- {{ html()->select('room_id')
                      ->class('form-control')
                      ->required() }} --}}
                  </div><!--col-->
              </div><!--form-group-->

            <div class="form-group row">
                {{ html()->label('Book Start')->class('col-md-2 form-control-label')->for('book_start') }}
                  <div class="col-md-10">
                      {{ html()->text('book_start')
                          ->class('form-control')
                          ->value(\Carbon\Carbon::parse($order->book_start)->format('m/d/Y'))
                          ->required() }}
                  </div><!--col-->
              </div><!--form-group-->
              <div class="form-group row">
                {{ html()->label('Book End')->class('col-md-2 form-control-label')->for('book_end') }}
                  <div class="col-md-10">
                      {{ html()->text('book_end')
                          ->class('form-control')
                          ->value(\Carbon\Carbon::parse($order->book_end)->format('m/d/Y'))
                          ->required() }}
                  </div><!--col-->
              </div><!--form-group-->
          </div>
        </div>

    </div>
    <div class="card-footer">
      <div class="row">
          <div class="col">
              @role('member')
              <a href="{{ route('booking.index') }}" class="btn btn-danger btn-sm">Cancel</a>
              @else
              <a href="{{ route('order.index') }}" class="btn btn-danger btn-sm">Cancel</a>
              @endrole
          </div><!--col-->

          <div class="col text-right">
            <button type="submit" class="btn btn-sm btn-success"><i class="fa fa-save"></i> Update</button>
              {{-- {{ form_submit('Update') }} --}}
          </div><!--row-->
      </div><!--row-->
    </div><!--card-footer-->
  </div>
  {{ html()->form()->close() }}
</div>
@endsection
@push('after-scripts')
<script>
$(document).ready(function() {
    $('#hotel_id').select2({
        theme: 'bootstrap4',
        width: '100%',
    });
    $('#room').select2({
        theme: 'bootstrap4',
        width: '100%',
    });

    $('#room').change(function () {
        if ($(this).val()) {
            console.log($('#hotel_id option:selected').val());
            console.log($('#room option:selected').val());
            var idHotel = $('#hotel_id option:selected').val();
            var roomType = $('#room option:selected').val();
            // $('#room_id').prop('disabled', false);
            $('#room_id').select2({
                width: '100%',
                theme: 'bootstrap4',
                minimumResultsForSearch: 1,
                placeholder: "Ketik 1 huruf untuk cari",
                ajax: {

                    url: '/api/room/available?hotel_id=' + idHotel +'&room=' + roomType,
                    type: 'GET',
                    dataType: 'json',
                    contentType:'application/json',
                    data: function (params) {
                        var query = {
                            q: params.term,
                        };
                        return query;
                    },
                    processResults: function (data, params) {
                        var myResults = [];
                        //console.log(data);
                        $.each(data, function (key, val) {
                            myResults.push({
                                'id': val.id,
                                'text': '['+ val.number + '] ' + val.type + ' - Rp ' + val.price
                            });
                        });
                        params.page = params.page || 1;
                        var paginate = (params.page * 10) < data.count_filtered;

                        return {
                            results: myResults,
                            pagination: {
                                more: paginate
                            }
                        };

                    },
                    //cache: true
                }
            });
        }
    });
});
</script>
@endpush

resources/views/internal/order/index.blade.php
@extends('layouts.backend')

@section('content')
<div class="container-fluid">

  <!-- Page Heading -->
  <h1 class="h3 mb-2 text-gray-800">Order List</h1>
  <p class="mb-4">Admin / Manager / Member can list order to a room in hotel, based on each role.</p>

  <!-- DataTales Example -->
  <div class="card shadow mb-4">
    <div class="card-header py-3">
      <h6 class="m-0 font-weight-bold text-primary">Order List
        @role('member')
        <a href="{{ route('booking.create') }}" type="button" class="btn btn-sm btn-primary float-right"><i class="fa fa-sign"></i> Add Booking Order</a></h6>
        @else
      <a href="{{ route('order.create') }}" type="button" class="btn btn-sm btn-primary float-right"><i class="fa fa-sign"></i> Add Booking Order</a></h6>
        @endrole
    </div>
    <div class="card-body">
      <div class="table-responsive">
        <table class="table table-sm">
          <thead class="thead">
            <tr>
              <th class="text-center">#</th>
              <th class="text-center">Cutomer Name</th>
              <th class="text-center">Hotel</th>
              <th class="text-center">Room Type & Number</th>
              <th class="text-center">Book Start</th>
              <th class="text-center">Book End</th>
              <th class="text-center">Status</th>
              <th class="text-center">Last Update</th>
              <th ></th>
            </tr>
          </thead>
          <tbody>
            @foreach ($orders as $key => $order)
              <tr>
                <td class="text-center">ID: {{ $order->id }}</td>
                <td>{{ $order->user->name }}</td>
                <td>{{ $order->hotel->name }}</td>
                <td>{{ Ucwords($order->room->type).' ['.$order->room->number.']' }}</td>
                <td>{{ \Carbon\Carbon::parse($order->book_start)->format('d F Y') }}</td>
                <td>{{ \Carbon\Carbon::parse($order->book_end)->format('d F Y') }}</td>
                <td>{{ $order->payment_status }}</td>
                <td>{{ $order->updated_at->diffForHumans() }}</td>
                <td >
                  <div class="btn-group" role="group" aria-label="User Actions">
                    @role('member')
                    <a href="{{ route('booking.show', $order->id ) }}" data-toggle="tooltip" data-placement="top" title="" class="btn btn-info" data-original-title="View">
                        <i class="fas fa-eye"></i>
                    </a>
                    <a href="{{ route('booking.edit', $order->id ) }}" data-toggle="tooltip" data-placement="top" title="" class="btn btn-primary" data-original-title="Edit">
                        <i class="fas fa-edit"></i>
                    </a>
                    @else
                    <a href="{{ route('order.show', $order->id ) }}" data-toggle="tooltip" data-placement="top" title="" class="btn btn-info" data-original-title="View">
                        <i class="fas fa-eye"></i>
                    </a>
                    <a href="{{ route('order.edit', $order->id ) }}" data-toggle="tooltip" data-placement="top" title="" class="btn btn-primary" data-original-title="Edit">
                        <i class="fas fa-edit"></i>
                    </a>
                    @endrole
                    <button type="button" id="btnDelete" data-id="{{$order->id}}" data-name="{{$order->user->name}}"  class="btn btn-danger btnDelete" >
                        <i class="fas fa-times"></i>
                    </button>
                </div>
                </td>
              </tr>
            @endforeach
          </tbody>
        </table>
        {{ $orders->links()  }}
      </div>
    </div>
  </div>

</div>
@endsection
@push('after-scripts')
<script>
$(document).ready(function() {
    $('.btnDelete').each(function(index) {
        $(this).on("click", function(){
            var id = $(this).data('id');
            var name = $(this).data('name');
            var content = document.createElement('div');
                content.innerHTML = 'Anda yakin ingin hapus Order dari Hotel? <code>'+name+'</code>';

            Swal.fire({
                // position: 'bottom-end',
                icon: 'error',
                title: 'Delete Order?',
                html: content,
                showCancelButton: true,
                confirmButtonColor: '#3085d6',
                cancelButtonColor: '#d33',
                confirmButtonText: 'Yes, delete it!'
                // toast: true,
                // timer: 3000,
                // showConfirmButton: false,

                // footer: '<a href>Why do I have this issue?</a>'
            }).then((result) => {
                if (result.value) {

                    $.ajax({
                        type: "DELETE",
                        url: "order/"+id,

                        headers: {
                            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
                        },
                        cache: false,
                        success: function(response) {
                            Swal.fire(
                            'Deleted!',
                            'Your Order has been deleted.',
                            'success'
                            ).then(function() {
                                window.location.reload(1);
                            });

                        },
                        error: function (response) {
                            console.log(response.responseJSON.message);
                            Swal.fire(
                            'Error!',
                            response.responseJSON.message,
                            'error'
                            );
                        }
                    })

                }
                })
            });
        });
});
</script>
@endpush